const LocalStrategy = require('passport-local').Strategy;
const bcrypt = require('bcrypt');

module.exports = (User, salt) => new LocalStrategy(
  (username, password, done) => {
    bcrypt.hash(password, salt, (err, hash) => {
      User
        .findOne({ where: { pseudo: username, mdp: hash } })
        .then(user => done(null, user))
        .catch(() => done(null, false));
    });
  }
);